import { feature } from 'topojson';
import { csv, json } from 'd3';

export const loadAndProcessData = () => 
  Promise
    .all([
      csv('https://gist.githubusercontent.com/mkt-ds/640984c80835e2823c1b0f5c9a3fabe6/raw/453c9e89719c45e5870fa8c80485dc47239430e3/happiness_byCountryCode.csv'),
      json('https://unpkg.com/visionscarto-world-atlas@0.0.4/world/50m.json')
    ])
    .then(([unData, topoJSONdata]) => {
     
      const rowById = unData.reduce((accumulator, d) => {
        accumulator[d['country_code']] = d;      
        return accumulator;
      }, {});

      const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

      countries.features.forEach(d => {
        Object.assign(d.properties, rowById[+d.id]);
      });
      
      const featuresWithPopulation = countries.features
        .filter(d => d.properties['population'])
        .map(d => {
          //d.properties['population'] = +d.properties['population'].replace(/ /g, '') * 1000;
          d.properties['population'] = +d.properties['population'];
          return d;
        });

      return {
        features: countries.features,
        featuresWithPopulation
      };
    });
